;copywrite 2001 by Samuel Stearley.



	include	"os.h"
	xdef		_ti89
	xdef		_ti92plus
	xdef		_nostub



	movem.l	d3-d7/a2-a6,-(a7)
	move.l	200,a6
	move.l	a7,d7
	lea		h1(pc),a0
	clr.w		(a0)			;zero intiate handle of entry
	clr.w		8(a0)			;"			     " answer

;----Install an error frame----------

	moveq		#70,d0
	sub.l		d0,a7
	move.l	a7,d0
	move.l	d0,-(a7)		;push the pointer
	move.l	1360(a6),a0
	jsr		(a0)
	tst.w		d0
	beq		NoError
	clr.w		-(a7)			;no enter-goto
	move.w	d0,-(a7)		;the error msg #
	move.l	1348(a6),a0		;get the display error msg box
	jsr		(a0)
	bra		Error			;maybe need to free allocated memory

;----Initiation-------

NoError:
	move.l	3324(a6),a0		;get command display home
	jsr		(a0)

;----Mess with the first window-----

	move.l	(a6),a0
	move.l	(a0),a0		;get the pointer
	bset.w	#$D,(a0)		;mark the window as dirty
	moveq		#0,d0
	move.b	18(a0),d0		;get byte
	sub.b		16(a0),d0		;now have the width of screen
	move.w	d0,-(a7)		;save it

;-----Now to get the arguments--------

	move.l	1060(a6),a5		;get pointer to top estack pointer
	move.l	3852(a6),a1		;get argument counter call
	move.l	(a5),a4
	move.l	a4,-(a7)		;top estack is input to count argument
	jsr		(a1)			;count argument
	subq.w	#1,d0
	bcs		PrintHelp		
	beq.s		OneArgument

;-----Code for two arguments-------

	lea		entry(pc),a3	
	moveq		#1,d5			;parse flag
	bsr		Analyzer
	move.l	a4,-(a7)		;put esi onto the stack
	move.l	1064(a6),a0		;get call to find the next string name
	jsr		(a0)
	move.l	a0,a4
	addq.l	#4,a7
	bra		AnalyzeAnswer

;----Code for one argument-------

OneArgument:
	lea		entry(pc),a3	
	moveq		#1,d5
	bsr		Analyzer
AnalyzeAnswer:
	lea		answer(pc),a3
	clr.w		d5
	bsr		Analyzer

;----ANALYSIS OF THE DATA IS DONE.
;----IT IS NOW TIME TO ADD THE ITEMS
;----TO THE HISTORY.

	move.l	868(a6),a5		;get the mode setting fill call
	jsr		(a5)			;fill the structure with the correct settings
	move.w	6(a5),a5		;get pointer to that stuff that was filled
	move.l	2324(a6),a0		;new fifo node- it will just allocate memory
	jsr		(a0)			;  and set it to zero and return a handle.
	move.w	d0,-(a7)
	beq		Error
	move.l	600(a6),a4		;get dereference call
	jsr		(a4)
	lea		26(a0),a1		;get pointer to answer stuff of the fifo node
	lea		entry(pc),a2	;get pointer to the entry data a3 will have already
						;  been loaded with the pointer to the answer.

;---INSERT THE DISTANCES FROM THE LEFT EDGE OF THE SCREEN.
;---A0 WILL MOVE THROUGHT THE ENTRY DATA OF THE FIFO NODE
;---AND A1 WILL MOVE THROUGH THE ANSWER DATA OF THE FIFO
;---NODE.

	move.w	#8,(a0)+		;distance entry is from left edge
	move.w	#8,(a1)		;distance answer is from left edge if it is too big
	move.w	4(a3),d0		;get width of the answer
	move.w	6(a7),d1
	sub.w		d0,d1
	bcs.s		AnswerXIsFine
	addq.w	#1,d1
	cmp.w		#8,d1
	bcs.s		AnswerXIsFine
	move.w	d1,(a1)		;overwrite old answer distance from the edge.
AnswerXIsFine:
	addq.l	#2,a1

;---GET Ys OF FROM BOTTOM----

	moveq		#0,d5			;use word as long
	move.w	(a2)+,d0		;bottom half
	move.w	(a2)+,d1		;top half
	move.w	d1,d5
	add.w		d0,d5			;d5 now has height of the entry
	moveq		#0,d4
	move.w	(a3)+,d2		;bottom half
	move.w	(a3)+,d3		;top half
	move.w	d3,d4
	add.w		d2,d4			;d4 now has height of the answer
	cmp.l		d5,d4
	bcs.s		EntryIsBigger

;---If answer is bigger---

	move.l	d4,(a1)
	move.l	d4,d6
	moveq		#0,d0			;do not need bottom half of entry
	move.w	d2,d0			;move in the bottom half of the answer
	add.w		d1,d0			;add the top half of the entry
	move.l	d0,(a0)
	bra.s		Forward

;---if entry is bigger---

EntryIsBigger:
	move.l	d5,(a0)
	move.l	d5,d6
	moveq		#0,d2			;do not need bottom half of answer
	move.w	d0,d2			;get bottom half of entry
	add.w		d3,d2			;add the top half of the answer
	move.l	d2,(a1)

;---See if they are so wide that the entry needs be pushed up---

Forward:
	move.w	(a3),d2		;get answer width
	add.w		(a2),d2		;add entry width to it
	move.w	6(a7),d0
	sub.w		#17,d0
	cmp.w		d0,d2			;if the two are both small then they will be
						;  on the same line.
	bcs.s		NoNeedToPushUpEntry
	move.l	d4,(a1)		;use the height of the answer
	move.l	d5,d0
	add.l		d4,d0			;use height of answer plus height of entry
	move.l	d0,(a0)
	addq.l	#2,(a0)
	move.l	(a0),d6
NoNeedToPushUpEntry:
	addq.l	#1,(a0)+
	addq.l	#1,(a1)+

;---LEAVE THE DISTANCE ALREADY SCROLLED DATUM AT ZERO

	addq.l	#4,a1
	addq.l	#4,a0

;---PLACE THE WIDTHS OF EACH

	move.w	(a2)+,(a0)+
	move.w	(a3)+,(a1)+

;---PLACE THE HEIGHTS OF EACH, WHICH ARE ALREADY CALCULATED

	move.w	d5,(a0)+
	move.w	d4,(a1)+

;---PLACE THE Y CENTER VARIABLE

	move.w	d1,(a0)+
	move.w	d3,(a1)+

;---INSERT THE HANDLES

	move.w	(a2),(a0)+
	move.w	(a3),(a1)+

;---THE FLAGS

	moveq		#1,d0			;it fits on the screen and is pretty printed
	move.l	d0,(a0)+
	move.l	d0,(a1)+

;---EXPONENTIAL FORM  AND PRECISION---

	move.l	20(a5),d0		;get fix followed by exp
	subq.w	#1,d0			;exp is 1 too big
	swap		d0			;reverse them
	subq.w	#1,d0			;fix is also 1 too big
	move.l	d0,(a0)+
	move.l	d0,(a1)+		

;---I AM NOW DONE FILLING THE STRUCTURE SO ADD THE FILED IN HISTORY
;---ITEM TO THE REST OF THE FIFO NODES.

	move.l	2328(a6),a0		;get push fifo node call
	jsr		(a0)			;execute it- the input is the handle of the new fifo
						;  node, which is already on the stack
	addq.l	#4,d6			;increase the distance to move up the other fifo nodes
	jsr		(a4)			;dereference the handle

AddYLoop:
	move.w	52(a0),(a7)		;get handle of the next history pair
	beq.s		Exit
	jsr		(a4)			;dereference
	add.l		d6,2(a0)		;move up entry
	add.l		d6,28(a0)		;move up answer
	bra.s		AddYLoop

PrintHelp:
	pea		help(pc)
	move.l	920(a6),a0
	jsr		(a0)

;----AND EXIT-----

Exit:
	move.l	1364(a6),a0
	jsr		(a0)				;remove the error frame
	move.l	d7,a7				;reset the stack
	movem.l	(a7)+,d3-d7/a2-a6
	rts

;----check if memory is allocated and if so free it----

Error:
	subq.w	#2,a7
	move.l	604(a6),a2		;heap free
	move.w	h1(pc),(a7)
	beq		NextHandle
	jsr		(a2)
NextHandle:
	move.w	h2(pc),(a7)
	beq		Exit
	jsr		(a2)
	bra		Exit


;---INPUTS---------------------------------------
;a4 -> points to the name string tag
;d5 -> parse flags
;---OUTPUTS--------------------------------------
;The data pointed to by a3 is filled
;with the appropriate stuff.
;
;Memory is allocated.
;-------------------------------------------------
Analyzer:

;---Get Handle of the data and the number of bytes big it is----

	cmp.b		#$2D,(a4)		;string?
	bne.s		Error
	pea		-1(a4)		;point to end zero
	move.l	384(a6),a0		;symbol find call
	jsr		(a0)
	move.l	d0,-(a7)		;push hsym
	beq.s		Error
	move.l	484(a6),a0		;symbol dereference
	jsr		(a0)
	move.w	$c(a0),-(a7)	;put handle on the stack
	move.l	600(a6),a0		;dereference call
	jsr		(a0)			;get pointer to it
	moveq		#0,d6
	move.w	(a0)+,d6

;---Get type----

	lea		-1(a0,d6),a1	;point to the tag
	move.b	(a1),d0
	moveq		#(listEnd-listBegin)-1,d1
	lea		listBegin(pc),a1
findLoop:
	cmp.b		(a1)+,d0
	dbeq		d1,findLoop
	beq		Error			;if datum is a type that is not allowed then exit

;---Allocate a new handle for the data to be copied to---

	addq.l	#3,d6
	move.l	d6,-(a7)
	move.l	588(a6),a0
	jsr		(a0)
	move.w	d0,6(a3)
	beq.s		Error
	move.w	d0,d3

;---Copy data to this new handle-----

	move.w	d0,-(a7)
	move.l	600(a6),a0
	jsr		(a0)			;got pointer
	move.l	a0,a2
	subq.l	#2,d6
	move.w	d6,(a2)+
	move.b	#$E9,(a2)+
	subq.l	#2,d6			;got a counter
	addq.l	#6,a7			;a7 points to the source handle
	move.l	600(a6),a0
	jsr		(a0)			;now have a pointer to the source
	addq.l	#2,a0
CopyDataLoop:
	move.b	(a0)+,(a2)+
	dbra		d6,CopyDataLoop

;---NOW TO PARSE IT-----------------

	move.l	(a5),a2		;back up top of estack
	move.w	d5,-(a7)		;parse flags
	move.w	d3,-(a7)
	move.l	300(a6),a0		;get parse 2d multi call
	jsr		(a0)

;---NOW TO GET ITS DIMENSIONS-------

	pea		2(a3)			;top half
	pea		(a3)			;bottom half
	pea		4(a3)			;width
	move.l	a0,-(a7)		;parsed data
	move.l	308(a6),a0		;get parms 2d call
	jsr		(a0)

;---NOW TO FINALIZE-----------------

	move.l	a2,(a5)		;reset top estack
	lea		30(a7),a7
	rts

;----------------------------------
;THE DATA
;----------------------------------

	even	

entry:
	dc.w	0	;bottom half
	dc.w	0	;top half
	dc.w	0	;width
h1
	dc.w	0	;handle

answer:
	dc.w	0
	dc.w	0
	dc.w	0
h2
	dc.w	0


help:
	dc.b	"(""folder\name"",[""folder\name""])",0

listBegin:
	dc.b	$DD,$DE,$DF,$E0,$E1,$E2,$F8
listEnd:
	;data, graphDataBase, picture, text, figure, macro, other

	END		
